{   Denis Butorin. 02.01.04, E-Mail: subritto@ngs.ru;
Web: http://subritto.h1.ru}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ToolWin, ComCtrls, ExtCtrls, StdCtrls, Speech, ActiveX, ComObj;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    Speak: TSpeedButton;
    PauseSpeak: TSpeedButton;
    Stop: TSpeedButton;
    ComboBox1: TComboBox;
    Panel1: TPanel;
    Bevel1: TBevel;
    tagCHR: TButton;
    cbCHR: TComboBox;
    tagCTX: TButton;
    cbCTX: TComboBox;
    tagEmp: TButton;
    tagDEM: TButton;
    tagMRK: TButton;
    edMrk: TEdit;
    tagPAU: TButton;
    edPau: TEdit;
    tagPIT: TButton;
    edPit: TEdit;
    tagSPD: TButton;
    edSpd: TEdit;
    tagVOL: TButton;
    edVol: TEdit;
    tagRST: TButton;
    tagPro: TSpeedButton;
    tagRmS: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Bevel2: TBevel;
    trSpeed: TTrackBar;
    trPitch: TTrackBar;
    trVolume: TTrackBar;
    lbSpdL: TLabel;
    lbSpdH: TLabel;
    lbSpdC: TLabel;
    lbPitL: TLabel;
    lbPitC: TLabel;
    lbPitH: TLabel;
    lbVolL: TLabel;
    lbVolC: TLabel;
    lbVolH: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel3: TBevel;
    Label6: TLabel;
    btAbout: TButton;
    btGeneral: TButton;
    btLexicon: TButton;
    btTrain: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpeakClick(Sender: TObject);
    procedure PauseSpeakClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure tagCHRClick(Sender: TObject);
    procedure tagCTXClick(Sender: TObject);
    procedure tagEmpClick(Sender: TObject);
    procedure tagDEMClick(Sender: TObject);
    procedure tagRSTClick(Sender: TObject);
    procedure tagMRKClick(Sender: TObject);
    procedure tagPAUClick(Sender: TObject);
    procedure tagPITClick(Sender: TObject);
    procedure tagSPDClick(Sender: TObject);
    procedure tagVOLClick(Sender: TObject);
    procedure tagProClick(Sender: TObject);
    procedure tagRmSClick(Sender: TObject);
    procedure trSpeedChange(Sender: TObject);
    procedure trPitchChange(Sender: TObject);
    procedure trVolumeChange(Sender: TObject);
    procedure btAboutClick(Sender: TObject);
    procedure btGeneralClick(Sender: TObject);
    procedure btLexiconClick(Sender: TObject);
    procedure btTrainClick(Sender: TObject);
  private
    { Private declarations }
    fITTSCentral: ITTSCentral; { ,
            }

    fIAMM: IAudioMultimediaDevice;
      {    }

    aTTSEnum: ITTSEnum;
      {   }

    fpModeInfo: PTTSModeInfo;
      {   }

    fITTSAttributes: ITTSAttributes;
      {     (,   ..)}

    fITTSDialogs: ITTSDialogs;
      {      }

    Pause: Boolean;
  public
    { Public declarations }
    MaxSpeedVoice: DWord;
    MinSpeedVoice: DWord;
    MaxPitchVoice: Word;
    MinPitchVoice: Word;
    MaxVolumeVoice: DWord;
    MinVolumeVoice: DWord;

    SpeedVoice: DWord;
    PitchVoice: Word;
    VolumeVoice: DWord;
    P: DWord;
  end;

var
  Form1: TForm1;
  s: string;//   

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  NumFound : DWord;
  ModeInfo : TTSModeInfo;
begin
  try
    { }
    CoCreateInstance(CLSID_MMAudioDest, Nil, CLSCTX_ALL,
           IID_IAudioMultiMediaDevice, fIAMM);
  except
  end;
  {        
      ITTSEnum}
  CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
  aTTSEnum.Reset;//  
  aTTSEnum.Next(1, ModeInfo, @NumFound); {  }
  While NumFound > 0 do
   begin
     ComboBox1.Items.Add(String(ModeInfo.szModeName));
     aTTSEnum.Next(1, ModeInfo, @NumFound); { }
   end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
 NumFound: DWord;
 ModeInfo : TTSModeInfo;{     }
begin
   try
     CoCreateInstance(CLSID_MMAudioDest, Nil, CLSCTX_ALL,
           IID_IAudioMultiMediaDevice, fIAMM);
     CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
     aTTSEnum.Reset;
     {   }
     Form1.aTTSEnum.skip(ComboBox1.ItemIndex);
     aTTSEnum.Next(1, ModeInfo, @NumFound);
     if assigned(fpModeInfo) then
     { fpModeInfo   nil}
      dispose(fpModeInfo);
     new(fpModeInfo);
     fpModeInfo^:=ModeInfo;
     { }
     aTTSEnum.Select(fpModeInfo^.gModeID, fITTSCentral, IUnknown(fIAMM));

     //    fITTSCentral  
     if assigned(fITTSCentral) then
      begin
       //    
       if (TTSI_ITTSATTRIBUTES and fpModeInfo^.dwInterfaces) <> 0 then
        begin
         try
          //    
          OleCheck(fITTSCentral.QueryInterface(IID_ITTSAttributes, fITTSAttributes));

          //     
          If (TTSFEATURE_SPEED and fpModeInfo.dwFeatures) <> 0 then
           begin
            //    
            if not(TTSERR_NOTSUPPORTED = fITTSAttributes.SpeedGet(SpeedVoice)) then
             begin
              //    
              if not(TTSERR_NOTSUPPORTED = fITTSAttributes.SpeedSet(P)) then
                begin
                  trSpeed.Hint:=IntToStr(SpeedVoice);
                  {  }
                  //     min
                  fITTSAttributes.SpeedSet(TTSATTR_MINSPEED);
                  //     MinSpeedVoice
                  fITTSAttributes.SpeedGet(MinSpeedVoice);
                  lbSpdL.Caption := IntToStr(MinSpeedVoice);
                  {   ()}
                  fITTSAttributes.Speedset(TTSATTR_MAXSPEED);
                  fITTSAttributes.SpeedGet(MaxSpeedVoice);
                  lbSpdH.Caption := IntToStr(MaxSpeedVoice);
                  fITTSAttributes.SpeedSet(SpeedVoice);

                  trSpeed.Enabled := True;
                  trSpeed.Max := MaxSpeedVoice;
                  trSpeed.Min := MinSpeedVoice;
                  trSpeed.Position:= SpeedVoice;
                  trSpeed.Frequency := Trunc((MaxSpeedVoice - MinSpeedVoice) / 10);
                end;
             end;
           end
          else
           begin
            trSpeed.Enabled := False;
           end;

          If (TTSFEATURE_PITCH and fpModeInfo.dwFeatures) <> 0 then
           begin
            if not(TTSERR_NOTSUPPORTED = fITTSAttributes.PitchGet(PitchVoice)) then
             begin
              if not(TTSERR_NOTSUPPORTED = fITTSAttributes.PitchSet(P)) then
                begin
                  trPitch.Hint:=IntToStr(PitchVoice);

                  fITTSAttributes.PitchSet(TTSATTR_MINPITCH);
                  fITTSAttributes.PitchGet(MinPitchVoice);
                  lbPitL.Caption := IntToStr(MinPitchVoice);

                  fITTSAttributes.Pitchset(TTSATTR_MAXPitch);
                  fITTSAttributes.PitchGet(MaxPitchVoice);
                  lbPitH.Caption := IntToStr(MaxPitchVoice);
                  fITTSAttributes.PitchSet(PitchVoice);

                  trPitch.Enabled := True;
                  trPitch.Max := MaxPitchVoice;
                  trPitch.Min := MinPitchVoice;
                  trPitch.Position := PitchVoice;
                  trPitch.Frequency := Trunc((MaxPitchVoice - MinPitchVoice) / 10);
                end;
             end;
           end
          else
           begin
            trPitch.Enabled := False;
           end;


          if (TTSFEATURE_Volume and fpModeInfo.dwFeatures) <> 0 then
           begin
            // Volume ,    
            if not(TTSERR_NOTSUPPORTED = fITTSAttributes.VolumeGet(VolumeVoice)) then
             begin
              //    VolumeGet   , ...
              if not(TTSERR_NOTSUPPORTED = fITTSAttributes.VolumeSet(P)) then
               begin
                //...    .
                //  
                fITTSAttributes.VolumeSet(TTSATTR_MINVolume);
                fITTSAttributes.VolumeGet(MinVolumeVoice);
                //  
                fITTSAttributes.VolumeSet(TTSATTR_MAXVolume);
                fITTSAttributes.VolumeGet(MaxVolumeVoice);
                fITTSAttributes.VolumeSet(VolumeVoice);

                trVolume.Enabled := True;
                trVolume.Max:= MaxVolumeVoice;
                trVolume.Min := MinVolumeVoice;
                trVolume.Position := Trunc(VolumeVoice / 100000);
               end
             end
           end
          else
           begin
             trVolume.Enabled:=false;
           end;

         except
         end;
        end // if (TTSI_ITTSATTRIBUTES and
       else
        begin
         //    , ...
         try
          if assigned(fITTSAttributes) then
           fITTSAttributes := Nil;
          trSpeed.Enabled:=false;
          trPitch.Enabled:=false;
          trVolume.Enabled:=false;
         except
          fITTSAttributes := Nil;
         end;
        end;

       //   ,     ,  
       if (TTSI_ITTSDIALOGS and fpModeInfo^.dwInterfaces) <> 0 then
        OleCheck(fITTSCentral.QueryInterface(IID_ITTSDialogs, fITTSDialogs));

      end;//end if assigned(fITTSCentral)
   except
   end;
end;

procedure TForm1.SpeakClick(Sender: TObject);
var
  SData: TSData;
  BufRich: string;
begin
  if not assigned(fITTSCentral) then
   begin
    ShowMessage(' !');
    exit;
   end;
  BufRich:=copy(RichEdit1.Text, RichEdit1.SelStart,
                        length(RichEdit1.Text)-RichEdit1.SelStart);
  SData.dwSize := length(BufRich) + 1;
  SData.pData := pChar(BufRich);
  if pause then
   begin
    try
      fITTSCentral.AudioResume;
      Pause:=False;
    except
      exit;
    end;
   end
  else
   begin
    try
      //   dwFlags!   1.   0    !
      fITTSCentral.TextData(CHARSET_TEXT, 1, SData, nil,
                                            IID_ITTSBufNotifySink);
    except
    end;
   end;
end;

procedure TForm1.PauseSpeakClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
   begin
    ShowMessage(' !');
    exit;
   end;
  if Pause then
    exit;
  try
    fITTSCentral.AudioPause;
    pause:=True;
  except
  end;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
   begin
    showmessage(' !');
    exit;
   end;
  try
    fITTSCentral.AudioReset;
    Pause:=False;
  except
  end;
end;

///////////////////////////////////////////////////////////////////////////////
//  
procedure TForm1.tagCHRClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Chr="'+cbChr.Text+'"\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagCTXClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Ctx="'+cbCtx.Text+'"\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagEmpClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Emp\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagDEMClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Dem\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagRSTClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Rst\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagMRKClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Mrk='+edMrk.Text+'\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagPAUClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Pau='+edPau.Text+'\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagPITClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Pit='+edPit.Text+'\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagSPDClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Spd='+edSpd.Text+'\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagVOLClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 insert('\Vol='+edVol.Text+'\', s, RichEdit1.SelStart+1);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagProClick(Sender: TObject);
begin
 if tagPro.Down then
  begin
    s:=RichEdit1.Lines.Text;
    insert('\Pro=1\', s, RichEdit1.SelStart+1);
    RichEdit1.Lines.Text:=s;
    Label1.Caption := 'On';
  end
 else
  begin
    s:=RichEdit1.Lines.Text;
    insert('\Pro=0\', s, RichEdit1.SelStart+1);
    RichEdit1.Lines.Text:=s;
    Label1.Caption := 'Off';
  end;
end;

procedure TForm1.tagRmSClick(Sender: TObject);
begin
 if tagRmS.Down then
  begin
    s:=RichEdit1.Lines.Text;
    insert('\RmS=1\', s, RichEdit1.SelStart+1);
    RichEdit1.Lines.Text:=s;
    Label2.Caption := 'On';
  end
 else
  begin
    s:=RichEdit1.Lines.Text;
    insert('\RmS=0\', s, RichEdit1.SelStart+1);
    RichEdit1.Lines.Text:=s;
    Label2.Caption := 'Off';
  end;
end;

///////////////////////////////////////////////////////////////////////////////
//  
procedure TForm1.trSpeedChange(Sender: TObject);
begin
 try
   OleCheck(fITTSCentral.Inject(PChar('\Spd='+IntToStr(trSpeed.Position)+'\')));
   SpeedVoice:=trSpeed.Position;
   lbSpdC.Caption:=IntToStr(SpeedVoice);
 except
 end;
end;

procedure TForm1.trPitchChange(Sender: TObject);
begin
 try
   OleCheck(fITTSCentral.Inject(PChar('\Pit='+IntToStr(trPitch.Position)+'\')));
   PitchVoice:=trPitch.Position;
   lbPitC.Caption:=IntToStr(PitchVoice);
 except
 end;
end;

procedure TForm1.trVolumeChange(Sender: TObject);
begin
 try
   OleCheck(fITTSCentral.Inject(PChar('\Vol='+IntToStr(trVolume.Position)+'\')));
   lbVolC.Caption:=IntToStr(trVolume.Position);
 except
 end;
end;

//////////////////////////////////////////////////////////////////////////////
/////////////////////////////    \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
procedure TForm1.btAboutClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.AboutDlg(Handle, nil));
  except
  end;
end;

procedure TForm1.btGeneralClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.GeneralDlg(Handle, nil));
  except
  end;
end;

procedure TForm1.btLexiconClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.LexiconDlg(Handle, nil));
  except
  end;
end;

procedure TForm1.btTrainClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.TranslateDlg(Handle, nil));
  except
  end;
end;

end.
